#include "audio.h"
#include "ntsc_video.h"
#include <plib.h>

void init_audio(){
    // enable VREF
    CVREFOpen( CVREF_ENABLE | CVREF_OUTPUT_ENABLE | CVREF_RANGE_LOW | CVREF_SOURCE_AVDD | CVREF_STEP_0 );
    //CVRCON_setup = CVRCON; 
    
    // Open Timer
    OpenTimer3(T3_ON | T3_SOURCE_INT | T3_PS_1_1, 10500);
    
    DmaChnOpen(DMAbgm, 0, DMA_OPEN_AUTO); // setup DMA into auto mode
    //DmaChnSetTxfer(DMAbgm, bgm_audio_buffer, (void*)&CVRCON, BGM_SIZE*2, 2, 2);
    //DmaChnSetEventControl(DMAbgm, DMA_EV_START_IRQ(_TIMER_3_IRQ));
    
    DmaChnOpen(DMAhit, 0, DMA_OPEN_DEFAULT); // setup DMA into auto mode
    //DmaChnSetTxfer(DMAhit, jump_hit_audio_buffer, (void*)&CVRCON, JUMP_HIT_SIZE*2, 2, 2);
    DmaChnSetEventControl(DMAhit, DMA_EV_START_IRQ(_TIMER_3_IRQ));
}

void config_bgm(int n){
    // configures background soundtrack
    if (n == 0){
        DmaChnOpen(DMAbgm, 0, DMA_OPEN_AUTO);
        DmaChnSetTxfer(DMAbgm, bgm_audio_buffer, (void*)&CVRCON, BGM_SIZE*2, 2, 2);
    } else {
        DmaChnOpen(DMAbgm, 0, DMA_OPEN_DEFAULT);
        DmaChnSetTxfer(DMAbgm, lose_bgm_audio_buffer, (void*)&CVRCON, LOSE_BGM_SIZE*2, 2, 2);
    }
    DmaChnSetEventControl(DMAbgm, DMA_EV_START_IRQ(_TIMER_3_IRQ));
    DmaChnEnable(DMAbgm);
}

void config_hit(int n){
    // hit sound effect
    if (n == 0){
        DmaChnSetTxfer(DMAhit, menu_hit_audio_buffer, (void*)&CVRCON, MENU_HIT_SIZE*2, 2, 2);
    } else if (n == 1) {
        DmaChnSetTxfer(DMAhit, jump_hit_audio_buffer, (void*)&CVRCON, JUMP_HIT_SIZE*2, 2, 2);
    } else {
        DmaChnSetTxfer(DMAhit, upgrade_audio_buffer, (void*)&CVRCON, UPGRADE_SIZE*2, 2, 2);
    }
}

void config_speed(float k){
    // change timer period
    WritePeriod3(fix2int(multfix(int2fix(10500),float2fix(k))));
}